5d25c20ad713c3b1c54a08051d31f44cad70ce44
[openwrt/staging/aparcar.git] / target / linux / ipq40xx / base-files / lib / upgrade / linksys.sh
1 linksys_get_target_firmware() {
2 local cur_boot_part mtd_ubi0
3
4 cur_boot_part="$(/usr/sbin/fw_printenv -n boot_part)"
5 if [ -z "${cur_boot_part}" ]; then
6 mtd_ubi0=$(cat /sys/devices/virtual/ubi/ubi0/mtd_num)
7 case "$(grep -E "^mtd${mtd_ubi0}:" /proc/mtd | cut -d '"' -f 2)" in
8 kernel|rootfs)
9 cur_boot_part=1
10 ;;
11 alt_kernel|alt_rootfs)
12 cur_boot_part=2
13 ;;
14 esac
15 >&2 printf "Current boot_part='%s' selected from ubi0/mtd_num='%s'" \
16 "${cur_boot_part}" "${mtd_ubi0}"
17 fi
18
19 # OEM U-Boot for EA6350v3, EA8300 and MR8300; bootcmd=
20 # if test $auto_recovery = no;
21 # then bootipq;
22 # elif test $boot_part = 1;
23 # then run bootpart1;
24 # else run bootpart2;
25 # fi
26
27 case "$cur_boot_part" in
28 1)
29 fw_setenv -s - <<-EOF
30 boot_part 2
31 auto_recovery yes
32 EOF
33 printf "alt_kernel"
34 return
35 ;;
36 2)
37 fw_setenv -s - <<-EOF
38 boot_part 1
39 auto_recovery yes
40 EOF
41 printf "kernel"
42 return
43 ;;
44 *)
45 return
46 ;;
47 esac
48 }
49
50 linksys_is_factory_image() {
51 local board=$(board_name)
52 board=${board##*,}
53
54 # check matching footer signature
55 tail -c 256 $1 | grep -q -i "\.LINKSYS\.........${board}"
56 }
57
58 platform_do_upgrade_linksys() {
59 local magic_long="$(get_magic_long "$1")"
60
61 local rm_oem_fw_vols="squashfs ubifs" # from OEM [alt_]rootfs UBI
62 local vol
63
64 mkdir -p /var/lock
65 local part_label="$(linksys_get_target_firmware)"
66 touch /var/lock/fw_printenv.lock
67
68 if [ -z "$part_label" ]; then
69 echo "cannot find target partition"
70 exit 1
71 fi
72
73 local target_mtd=$(find_mtd_part "$part_label")
74
75 [ "$magic_long" = "73797375" ] && {
76 CI_KERNPART="$part_label"
77 if [ "$part_label" = "kernel" ]; then
78 CI_UBIPART="rootfs"
79 else
80 CI_UBIPART="alt_rootfs"
81 fi
82
83 local mtdnum="$(find_mtd_index "$CI_UBIPART")"
84 if [ ! "$mtdnum" ]; then
85 echo "cannot find ubi mtd partition $CI_UBIPART"
86 return 1
87 fi
88
89 local ubidev="$(nand_find_ubi "$CI_UBIPART")"
90 if [ ! "$ubidev" ]; then
91 ubiattach -m "$mtdnum"
92 sync
93 ubidev="$(nand_find_ubi "$CI_UBIPART")"
94 fi
95
96 if [ "$ubidev" ]; then
97 for vol in $rm_oem_fw_vols; do
98 ubirmvol "/dev/$ubidev" -N "$vol" 2>/dev/null
99 done
100 fi
101
102 # complete std upgrade
103 nand_upgrade_tar "$1"
104 }
105
106 [ "$magic_long" = "27051956" ] && {
107 echo "writing \"$1\" image to \"$part_label\""
108 get_image "$1" | mtd write - "$part_label"
109 }
110
111 [ "$magic_long" = "d00dfeed" ] && {
112 if ! linksys_is_factory_image "$1"; then
113 echo "factory image doesn't match device"
114 return 1
115 fi
116
117 echo "writing \"$1\" factory image to \"$part_label\""
118 get_image "$1" | mtd -e "$part_label" write - "$part_label"
119 }
120 }